"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from gusto_embedded.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class ContractorOnboardingStatusOnboardingStatus(str, Enum):
    r"""One of the \"onboarding_status\" enum values."""

    ONBOARDING_COMPLETED = "onboarding_completed"
    ADMIN_ONBOARDING_REVIEW = "admin_onboarding_review"
    ADMIN_ONBOARDING_INCOMPLETE = "admin_onboarding_incomplete"


class ContractorOnboardingStatusOnboardingStepTypedDict(TypedDict):
    title: NotRequired[str]
    r"""User-friendly description of the onboarding step."""
    id: NotRequired[str]
    r"""String identifier for the onboarding step."""
    required: NotRequired[bool]
    r"""When true, this step is required."""
    completed: NotRequired[bool]
    r"""When true, this step has been completed."""
    requirements: NotRequired[List[str]]
    r"""A list of onboarding steps required to begin this step."""


class ContractorOnboardingStatusOnboardingStep(BaseModel):
    title: Optional[str] = None
    r"""User-friendly description of the onboarding step."""

    id: Optional[str] = None
    r"""String identifier for the onboarding step."""

    required: Optional[bool] = None
    r"""When true, this step is required."""

    completed: Optional[bool] = None
    r"""When true, this step has been completed."""

    requirements: Optional[List[str]] = None
    r"""A list of onboarding steps required to begin this step."""


class ContractorOnboardingStatusTypedDict(TypedDict):
    r"""The representation of an contractor's onboarding status."""

    uuid: str
    r"""Unique identifier for this contractor."""
    onboarding_status: NotRequired[ContractorOnboardingStatusOnboardingStatus]
    r"""One of the \"onboarding_status\" enum values."""
    onboarding_steps: NotRequired[
        List[ContractorOnboardingStatusOnboardingStepTypedDict]
    ]
    r"""List of steps required to onboard a contractor."""


class ContractorOnboardingStatus(BaseModel):
    r"""The representation of an contractor's onboarding status."""

    uuid: str
    r"""Unique identifier for this contractor."""

    onboarding_status: Optional[ContractorOnboardingStatusOnboardingStatus] = None
    r"""One of the \"onboarding_status\" enum values."""

    onboarding_steps: Optional[List[ContractorOnboardingStatusOnboardingStep]] = None
    r"""List of steps required to onboard a contractor."""
