"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .versionheader import VersionHeader
from gusto_embedded.types import BaseModel
from gusto_embedded.utils import FieldMetadata, HeaderMetadata, PathParamMetadata
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetV1CompaniesCompanyUUIDTaxRequirementsRequestTypedDict(TypedDict):
    company_uuid: str
    r"""The UUID of the company"""
    x_gusto_api_version: NotRequired[VersionHeader]
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class GetV1CompaniesCompanyUUIDTaxRequirementsRequest(BaseModel):
    company_uuid: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The UUID of the company"""

    x_gusto_api_version: Annotated[
        Optional[VersionHeader],
        pydantic.Field(alias="X-Gusto-API-Version"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = VersionHeader.TWO_THOUSAND_AND_TWENTY_FOUR_MINUS_04_MINUS_01
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class ResponseBodyTypedDict(TypedDict):
    state: str
    r"""One of the two-letter state abbreviations for the fifty United States and the District of Columbia (DC)"""
    setup_complete: bool
    r"""If all requirements for the state have been satisfied such that the company can complete
    onboarding, the company is `setup_complete` in the state. A company must be `setup_complete` in
    all relevant states to complete the `state_setup` company onboarding step.
    """


class ResponseBody(BaseModel):
    state: str
    r"""One of the two-letter state abbreviations for the fifty United States and the District of Columbia (DC)"""

    setup_complete: bool
    r"""If all requirements for the state have been satisfied such that the company can complete
    onboarding, the company is `setup_complete` in the state. A company must be `setup_complete` in
    all relevant states to complete the `state_setup` company onboarding step.
    """
