"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .versionheader import VersionHeader
from enum import Enum
from gusto_embedded.types import BaseModel
from gusto_embedded.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    RequestMetadata,
)
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PostV1CompaniesCompanyIDBankAccountsAccountType(str, Enum):
    r"""The bank account type"""

    CHECKING = "Checking"
    SAVINGS = "Savings"


class PostV1CompaniesCompanyIDBankAccountsRequestBodyTypedDict(TypedDict):
    routing_number: NotRequired[str]
    r"""The bank routing number"""
    account_number: NotRequired[str]
    r"""The bank account number"""
    account_type: NotRequired[PostV1CompaniesCompanyIDBankAccountsAccountType]
    r"""The bank account type"""


class PostV1CompaniesCompanyIDBankAccountsRequestBody(BaseModel):
    routing_number: Optional[str] = None
    r"""The bank routing number"""

    account_number: Optional[str] = None
    r"""The bank account number"""

    account_type: Optional[PostV1CompaniesCompanyIDBankAccountsAccountType] = None
    r"""The bank account type"""


class PostV1CompaniesCompanyIDBankAccountsRequestTypedDict(TypedDict):
    company_id: str
    r"""The UUID of the company"""
    request_body: PostV1CompaniesCompanyIDBankAccountsRequestBodyTypedDict
    x_gusto_api_version: NotRequired[VersionHeader]
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class PostV1CompaniesCompanyIDBankAccountsRequest(BaseModel):
    company_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The UUID of the company"""

    request_body: Annotated[
        PostV1CompaniesCompanyIDBankAccountsRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    x_gusto_api_version: Annotated[
        Optional[VersionHeader],
        pydantic.Field(alias="X-Gusto-API-Version"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = VersionHeader.TWO_THOUSAND_AND_TWENTY_FOUR_MINUS_04_MINUS_01
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""
