"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .versionheader import VersionHeader
from gusto_embedded.types import BaseModel
from gusto_embedded.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    RequestMetadata,
)
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PostV1CompanySignatoriesHomeAddressTypedDict(TypedDict):
    r"""The signatory's home address"""

    street_1: str
    city: str
    state: str
    zip_code: str
    street_2: NotRequired[str]


class PostV1CompanySignatoriesHomeAddress(BaseModel):
    r"""The signatory's home address"""

    street_1: str

    city: str

    state: str

    zip_code: Annotated[str, pydantic.Field(alias="zip")]

    street_2: Optional[str] = None


class PostV1CompanySignatoriesRequestBodyTypedDict(TypedDict):
    ssn: str
    first_name: str
    last_name: str
    email: str
    title: str
    phone: str
    birthday: str
    home_address: PostV1CompanySignatoriesHomeAddressTypedDict
    r"""The signatory's home address"""
    middle_initial: NotRequired[str]


class PostV1CompanySignatoriesRequestBody(BaseModel):
    ssn: str

    first_name: str

    last_name: str

    email: str

    title: str

    phone: str

    birthday: str

    home_address: PostV1CompanySignatoriesHomeAddress
    r"""The signatory's home address"""

    middle_initial: Optional[str] = None


class PostV1CompanySignatoriesRequestTypedDict(TypedDict):
    company_uuid: str
    r"""The UUID of the company"""
    request_body: PostV1CompanySignatoriesRequestBodyTypedDict
    x_gusto_api_version: NotRequired[VersionHeader]
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class PostV1CompanySignatoriesRequest(BaseModel):
    company_uuid: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The UUID of the company"""

    request_body: Annotated[
        PostV1CompanySignatoriesRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    x_gusto_api_version: Annotated[
        Optional[VersionHeader],
        pydantic.Field(alias="X-Gusto-API-Version"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = VersionHeader.TWO_THOUSAND_AND_TWENTY_FOUR_MINUS_04_MINUS_01
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""
