"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .versionheader import VersionHeader
from enum import Enum
from gusto_embedded.types import BaseModel
from gusto_embedded.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    RequestMetadata,
)
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PutV1ContractorsContractorUUIDOnboardingStatusOnboardingStatus(str, Enum):
    r"""The updated onboarding status for the contractor"""

    ONBOARDING_COMPLETED = "onboarding_completed"


class PutV1ContractorsContractorUUIDOnboardingStatusRequestBodyTypedDict(TypedDict):
    onboarding_status: NotRequired[
        PutV1ContractorsContractorUUIDOnboardingStatusOnboardingStatus
    ]
    r"""The updated onboarding status for the contractor"""


class PutV1ContractorsContractorUUIDOnboardingStatusRequestBody(BaseModel):
    onboarding_status: Optional[
        PutV1ContractorsContractorUUIDOnboardingStatusOnboardingStatus
    ] = PutV1ContractorsContractorUUIDOnboardingStatusOnboardingStatus.ONBOARDING_COMPLETED
    r"""The updated onboarding status for the contractor"""


class PutV1ContractorsContractorUUIDOnboardingStatusRequestTypedDict(TypedDict):
    contractor_uuid: str
    r"""The UUID of the contractor"""
    request_body: PutV1ContractorsContractorUUIDOnboardingStatusRequestBodyTypedDict
    x_gusto_api_version: NotRequired[VersionHeader]
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class PutV1ContractorsContractorUUIDOnboardingStatusRequest(BaseModel):
    contractor_uuid: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The UUID of the contractor"""

    request_body: Annotated[
        PutV1ContractorsContractorUUIDOnboardingStatusRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    x_gusto_api_version: Annotated[
        Optional[VersionHeader],
        pydantic.Field(alias="X-Gusto-API-Version"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = VersionHeader.TWO_THOUSAND_AND_TWENTY_FOUR_MINUS_04_MINUS_01
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""
