"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from .basesdk import BaseSDK
from .httpclient import AsyncHttpClient, ClientOwner, HttpClient, close_clients
from .sdkconfiguration import SDKConfiguration
from .utils.logger import Logger, get_default_logger
from .utils.retries import RetryConfig
from gusto_embedded import models, utils
from gusto_embedded._hooks import SDKHooks
from gusto_embedded.achtransactions import AchTransactions
from gusto_embedded.bankaccounts import BankAccounts
from gusto_embedded.companies import Companies
from gusto_embedded.companyattachment_sdk import CompanyAttachmentSDK
from gusto_embedded.companyattachments import CompanyAttachments
from gusto_embedded.companybenefits import CompanyBenefits
from gusto_embedded.companyforms import CompanyForms
from gusto_embedded.contractordocuments import ContractorDocuments
from gusto_embedded.contractorforms import ContractorForms
from gusto_embedded.contractorpaymentgroups import ContractorPaymentGroups
from gusto_embedded.contractorpaymentmethod_sdk import ContractorPaymentMethodSDK
from gusto_embedded.contractorpaymentmethods import ContractorPaymentMethods
from gusto_embedded.contractorpayments import ContractorPayments
from gusto_embedded.contractors import Contractors
from gusto_embedded.departments import Departments
from gusto_embedded.earningtypes import EarningTypes
from gusto_embedded.employeeaddresses import EmployeeAddresses
from gusto_embedded.employeebenefits import EmployeeBenefits
from gusto_embedded.employeeemployments import EmployeeEmployments
from gusto_embedded.employeeforms import EmployeeForms
from gusto_embedded.employeepaymentmethod_sdk import EmployeePaymentMethodSDK
from gusto_embedded.employeepaymentmethods import EmployeePaymentMethods
from gusto_embedded.employees import Employees
from gusto_embedded.employeetaxsetup import EmployeeTaxSetup
from gusto_embedded.events import Events
from gusto_embedded.externalpayrolls import ExternalPayrolls
from gusto_embedded.federaltaxdetails_sdk import FederalTaxDetailsSDK
from gusto_embedded.flows import Flows
from gusto_embedded.garnishments import Garnishments
from gusto_embedded.generateddocuments import GeneratedDocuments
from gusto_embedded.historicalemployees import HistoricalEmployees
from gusto_embedded.holidaypaypolicies import HolidayPayPolicies
from gusto_embedded.i9verification import I9Verification
from gusto_embedded.industryselection import IndustrySelection
from gusto_embedded.introspection import Introspection
from gusto_embedded.invoices import Invoices
from gusto_embedded.jobsandcompensations import JobsAndCompensations
from gusto_embedded.locations import Locations
from gusto_embedded.notifications import Notifications
from gusto_embedded.paymentconfigs_sdk import PaymentConfigsSDK
from gusto_embedded.payrolls import Payrolls
from gusto_embedded.payschedules import PaySchedules
from gusto_embedded.recoverycases import RecoveryCases
from gusto_embedded.reports import Reports
from gusto_embedded.signatories import Signatories
from gusto_embedded.taxrequirements import TaxRequirements
from gusto_embedded.timeoffpolicies import TimeOffPolicies
from gusto_embedded.types import OptionalNullable, UNSET
from gusto_embedded.webhooks import Webhooks
from gusto_embedded.wireinrequests import WireInRequests
import httpx
from typing import Any, Callable, Dict, Optional, Union, cast
import weakref


class Gusto(BaseSDK):
    r"""Gusto API: Welcome to Gusto's Embedded Payroll API documentation!"""

    introspection: Introspection
    companies: Companies
    invoices: Invoices
    company_attachments: CompanyAttachments
    company_attachment: CompanyAttachmentSDK
    federal_tax_details: FederalTaxDetailsSDK
    industry_selection: IndustrySelection
    signatories: Signatories
    flows: Flows
    locations: Locations
    bank_accounts: BankAccounts
    external_payrolls: ExternalPayrolls
    payment_configs: PaymentConfigsSDK
    pay_schedules: PaySchedules
    employees: Employees
    historical_employees: HistoricalEmployees
    departments: Departments
    employee_employments: EmployeeEmployments
    employee_addresses: EmployeeAddresses
    employee_tax_setup: EmployeeTaxSetup
    employee_payment_method: EmployeePaymentMethodSDK
    employee_payment_methods: EmployeePaymentMethods
    jobs_and_compensations: JobsAndCompensations
    earning_types: EarningTypes
    contractors: Contractors
    contractor_payment_methods: ContractorPaymentMethods
    contractor_payment_method: ContractorPaymentMethodSDK
    webhooks: Webhooks
    contractor_forms: ContractorForms
    contractor_documents: ContractorDocuments
    employee_forms: EmployeeForms
    payrolls: Payrolls
    time_off_policies: TimeOffPolicies
    contractor_payments: ContractorPayments
    contractor_payment_groups: ContractorPaymentGroups
    company_forms: CompanyForms
    generated_documents: GeneratedDocuments
    reports: Reports
    company_benefits: CompanyBenefits
    employee_benefits: EmployeeBenefits
    garnishments: Garnishments
    i9_verification: I9Verification
    tax_requirements: TaxRequirements
    holiday_pay_policies: HolidayPayPolicies
    notifications: Notifications
    events: Events
    recovery_cases: RecoveryCases
    ach_transactions: AchTransactions
    wire_in_requests: WireInRequests

    def __init__(
        self,
        company_access_auth: Optional[
            Union[Optional[str], Callable[[], Optional[str]]]
        ] = None,
        server: Optional[str] = None,
        server_url: Optional[str] = None,
        url_params: Optional[Dict[str, str]] = None,
        client: Optional[HttpClient] = None,
        async_client: Optional[AsyncHttpClient] = None,
        retry_config: OptionalNullable[RetryConfig] = UNSET,
        timeout_ms: Optional[int] = None,
        debug_logger: Optional[Logger] = None,
    ) -> None:
        r"""Instantiates the SDK configuring it with the provided parameters.

        :param company_access_auth: The company_access_auth required for authentication
        :param server: The server by name to use for all methods
        :param server_url: The server URL to use for all methods
        :param url_params: Parameters to optionally template the server URL with
        :param client: The HTTP client to use for all synchronous methods
        :param async_client: The Async HTTP client to use for all asynchronous methods
        :param retry_config: The retry configuration to use for all supported methods
        :param timeout_ms: Optional request timeout applied to each operation in milliseconds
        """
        client_supplied = True
        if client is None:
            client = httpx.Client()
            client_supplied = False

        assert issubclass(
            type(client), HttpClient
        ), "The provided client must implement the HttpClient protocol."

        async_client_supplied = True
        if async_client is None:
            async_client = httpx.AsyncClient()
            async_client_supplied = False

        if debug_logger is None:
            debug_logger = get_default_logger()

        assert issubclass(
            type(async_client), AsyncHttpClient
        ), "The provided async_client must implement the AsyncHttpClient protocol."

        security: Any = None
        if callable(company_access_auth):
            # pylint: disable=unnecessary-lambda-assignment
            security = lambda: models.Security(
                company_access_auth=company_access_auth()
            )
        else:
            security = models.Security(company_access_auth=company_access_auth)

        if server_url is not None:
            if url_params is not None:
                server_url = utils.template_url(server_url, url_params)

        BaseSDK.__init__(
            self,
            SDKConfiguration(
                client=client,
                client_supplied=client_supplied,
                async_client=async_client,
                async_client_supplied=async_client_supplied,
                security=security,
                server_url=server_url,
                server=server,
                retry_config=retry_config,
                timeout_ms=timeout_ms,
                debug_logger=debug_logger,
            ),
        )

        hooks = SDKHooks()

        current_server_url, *_ = self.sdk_configuration.get_server_details()
        server_url, self.sdk_configuration.client = hooks.sdk_init(
            current_server_url, client
        )
        if current_server_url != server_url:
            self.sdk_configuration.server_url = server_url

        # pylint: disable=protected-access
        self.sdk_configuration.__dict__["_hooks"] = hooks

        weakref.finalize(
            self,
            close_clients,
            cast(ClientOwner, self.sdk_configuration),
            self.sdk_configuration.client,
            self.sdk_configuration.client_supplied,
            self.sdk_configuration.async_client,
            self.sdk_configuration.async_client_supplied,
        )

        self._init_sdks()

    def _init_sdks(self):
        self.introspection = Introspection(self.sdk_configuration)
        self.companies = Companies(self.sdk_configuration)
        self.invoices = Invoices(self.sdk_configuration)
        self.company_attachments = CompanyAttachments(self.sdk_configuration)
        self.company_attachment = CompanyAttachmentSDK(self.sdk_configuration)
        self.federal_tax_details = FederalTaxDetailsSDK(self.sdk_configuration)
        self.industry_selection = IndustrySelection(self.sdk_configuration)
        self.signatories = Signatories(self.sdk_configuration)
        self.flows = Flows(self.sdk_configuration)
        self.locations = Locations(self.sdk_configuration)
        self.bank_accounts = BankAccounts(self.sdk_configuration)
        self.external_payrolls = ExternalPayrolls(self.sdk_configuration)
        self.payment_configs = PaymentConfigsSDK(self.sdk_configuration)
        self.pay_schedules = PaySchedules(self.sdk_configuration)
        self.employees = Employees(self.sdk_configuration)
        self.historical_employees = HistoricalEmployees(self.sdk_configuration)
        self.departments = Departments(self.sdk_configuration)
        self.employee_employments = EmployeeEmployments(self.sdk_configuration)
        self.employee_addresses = EmployeeAddresses(self.sdk_configuration)
        self.employee_tax_setup = EmployeeTaxSetup(self.sdk_configuration)
        self.employee_payment_method = EmployeePaymentMethodSDK(self.sdk_configuration)
        self.employee_payment_methods = EmployeePaymentMethods(self.sdk_configuration)
        self.jobs_and_compensations = JobsAndCompensations(self.sdk_configuration)
        self.earning_types = EarningTypes(self.sdk_configuration)
        self.contractors = Contractors(self.sdk_configuration)
        self.contractor_payment_methods = ContractorPaymentMethods(
            self.sdk_configuration
        )
        self.contractor_payment_method = ContractorPaymentMethodSDK(
            self.sdk_configuration
        )
        self.webhooks = Webhooks(self.sdk_configuration)
        self.contractor_forms = ContractorForms(self.sdk_configuration)
        self.contractor_documents = ContractorDocuments(self.sdk_configuration)
        self.employee_forms = EmployeeForms(self.sdk_configuration)
        self.payrolls = Payrolls(self.sdk_configuration)
        self.time_off_policies = TimeOffPolicies(self.sdk_configuration)
        self.contractor_payments = ContractorPayments(self.sdk_configuration)
        self.contractor_payment_groups = ContractorPaymentGroups(self.sdk_configuration)
        self.company_forms = CompanyForms(self.sdk_configuration)
        self.generated_documents = GeneratedDocuments(self.sdk_configuration)
        self.reports = Reports(self.sdk_configuration)
        self.company_benefits = CompanyBenefits(self.sdk_configuration)
        self.employee_benefits = EmployeeBenefits(self.sdk_configuration)
        self.garnishments = Garnishments(self.sdk_configuration)
        self.i9_verification = I9Verification(self.sdk_configuration)
        self.tax_requirements = TaxRequirements(self.sdk_configuration)
        self.holiday_pay_policies = HolidayPayPolicies(self.sdk_configuration)
        self.notifications = Notifications(self.sdk_configuration)
        self.events = Events(self.sdk_configuration)
        self.recovery_cases = RecoveryCases(self.sdk_configuration)
        self.ach_transactions = AchTransactions(self.sdk_configuration)
        self.wire_in_requests = WireInRequests(self.sdk_configuration)

    def __enter__(self):
        return self

    async def __aenter__(self):
        return self

    def __exit__(self, exc_type, exc_val, exc_tb):
        if (
            self.sdk_configuration.client is not None
            and not self.sdk_configuration.client_supplied
        ):
            self.sdk_configuration.client.close()
        self.sdk_configuration.client = None

    async def __aexit__(self, exc_type, exc_val, exc_tb):
        if (
            self.sdk_configuration.async_client is not None
            and not self.sdk_configuration.async_client_supplied
        ):
            await self.sdk_configuration.async_client.aclose()
        self.sdk_configuration.async_client = None
